



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>LVS+Keepalive+Nginx实现负载均衡</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">LVS+Keepalive+Nginx实现负载均衡</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-04 02:55:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本文参考：http://blog.csdn.net/yinwenjie/article/details/47211551</p>
<p>简单粗暴写一下，做备忘，刚刚搭好没做优化呢，后期补充</p>
<p>一、机器准备</p>
<div>
<pre class="prettyprint linenums">LVS-Master  192.168.100.2　　　 主LVS<br />
LVS-BACKUP 192.168.100.3　　　　备LVS<br />
WEB1　　　　192.168.100.11　　　 nginx1<br />
WEB2　　　　192.168.100.12　　　 nginx2<br />
WEB3　　　　192.168.100.13　　　 nginx3<br />vip 　　　　192.168.100.1　　　　 虚拟IP</pre>
</div>
<p>　　</p>
<p>主机名统一更新，可以自定义名称，我这里统一命名，LVS-Master、LVS-BACKUP、WEB1、WEB2、WEB3</p>
<p>二、安装配置Keepalive</p>
<div>
<pre class="prettyprint linenums">yum install -y zlib zlib-devel gcc gcc-c++ openssl openssl-devel openssh<br />
yum install keepalive* -y //如果yum里面没有请编译安装一下<br />
cp /etc/keepalived/keepalived.conf /etc/keepalived/bck_keepalived.conf  //先做个备份，防止操作错误
</pre>
</div>
<p>vi keepalived.conf</p>
<div>
<pre class="prettyprint linenums">! Configuration File for keepalived

global_defs {<br />
   #notification_email {<br />
   #  acassen@firewall.loc<br />
   #  failover@firewall.loc<br />
   #  sysadmin@firewall.loc<br />
   #}<br />
   #notification_email_from Alexandre.Cassen@firewall.loc<br />
   #smtp_server 192.168.200.1<br />
   #smtp_connect_timeout 30<br />
   router_id LVS_DEVEL<br />
}

vrrp_instance VI_1 {<br />
    #141节点设置为MASTER，142或者还有其他的节点设置为BACKUP<br />
    #还记得我们前面文章讲到的无抢占设置吗？这里也可以用哦。<br />
    state BACKUP<br />
    #网络适配器名称<br />
    interface eth0<br />
    virtual_router_id 51<br />
    #所有的SLAVE节点的优先级都要比这个设置值低<br />
    priority 120<br />
    advert_int 1<br />
    #真实ip，主LVS和备份LVS要改成相应的lvs节点真实ip<br />
    mcast_src_ip=192.168.100.3<br />
    authentication {<br />
        auth_type PASS<br />
        auth_pass 1111<br />
    }<br />
    #虚拟/浮动IP<br />
    virtual_ipaddress {<br />
        192.168.100.1<br />
    }<br />
}

virtual_server 192.168.100.1 80 {<br />
    #健康时间检查，单位秒<br />
    delay_loop 6<br />
    #负载均衡调度算法wlc|rr，和您将使用的LVS的调度算法保持原则一致<br />
    lb_algo rr<br />
    #负载均衡转发规则 DR NAT TUN。和您将启动的LVS的工作模式设置一致<br />
    lb_kind DR<br />
    #虚拟地址的子网掩码<br />
    nat_mask 255.255.255.0<br />
    #会话保持时间，因为我们经常使用的是无状态的集群架构，所以这个设置可有可无<br />
    #persistence_timeout 50<br />
    #转发协议，当然是TCP<br />
    protocol TCP

    #真实的下层Nginx节点的健康监测<br />
    real_server 192.168.100.11 80 {<br />
        #节点权重，<br />
        weight 10<br />
        #设置检查方式，可以设置HTTP_GET | SSL_GET<br />
        HTTP_GET {<br />
            url {<br />
              path /<br />
              digest ff20ad2481f97b1754ef3e12ecd3a9cc<br />
            }<br />
            #超时时间，秒。如果在这个时间内没有返回，则说明一次监测失败<br />
            connect_timeout 3<br />
            #设置多少次监测失败，就认为这个真实节点死掉了<br />
            nb_get_retry 3<br />
            #重试间隔<br />
            delay_before_retry 3<br />
        }<br />
    }

    real_server 192.168.100.12 80 {<br />
        weight 10<br />
        HTTP_GET {<br />
            url {<br />
              path /<br />
              digest 640205b7b0fc66c1ea91c463fac6334d<br />
            }<br />
            connect_timeout 3<br />
            nb_get_retry 3<br />
            delay_before_retry 3<br />
        }<br />
    }

    real_server 192.168.100.13 80 {<br />
    weight 10<br />
    HTTP_GET {<br />
        url {<br />
          path /<br />
          digest 640205b7b0fc66c1ea91c463fac6334d<br />
        }<br />
        connect_timeout 3<br />
        nb_get_retry 3<br />
        delay_before_retry 3<br />
    }<br />
}

}
</pre>
</div>
<p>/etc/init.d/keepalived restart &nbsp;//启动服务 &nbsp; &nbsp; 启动后可以在/var/log/messages 看看有没有启动报错　</p>
<p>三、LVS安装配置</p>
<p>先列出了lvs管理工具的一些参数，供下面命令参考。</p>
<div>
<pre class="prettyprint linenums">-A &ndash;add-service 在内核的虚拟服务器表中添加一条新的虚拟服务器记录。也就是增加一台新的虚拟服务器。<br />
-E &ndash;edit-service 编辑内核虚拟服务器表中的一条虚拟服务器记录。<br />
-D &ndash;delete-service 删除内核虚拟服务器表中的一条虚拟服务器记录。<br />
-C &ndash;clear 清除内核虚拟服务器表中的所有记录。<br />
-R &ndash;restore 恢复虚拟服务器规则<br />
-S &ndash;save 保存虚拟服务器规则，输出为-R 选项可读的格式<br />
-a &ndash;add-server 在内核虚拟服务器表的一条记录里添加一条新的真实服务器记录。也就是在一个虚拟服务器中增加一台新的真实服务器<br />
-e &ndash;edit-server 编辑一条虚拟服务器记录中的某条真实服务器记录<br />
-d &ndash;delete-server 删除一条虚拟服务器记录中的某条真实服务器记录<br />
-L &ndash;list 显示内核虚拟服务器表<br />
-Z &ndash;zero 虚拟服务表计数器清零（清空当前的连接数量等）<br />
&ndash;set tcp tcpfin udp 设置连接超时值<br />
&ndash;start-daemon 启动同步守护进程。他后面可以是master 或backup，用来说明LVS Router 是master 或是backup。在这个功能上也可以采用keepalived 的VRRP 功能。<br />
&ndash;stop-daemon 停止同步守护进程<br />
-t &ndash;tcp-service service-address 说明虚拟服务器提供的是tcp 的服务[vip:port] or [real-server-ip:port]<br />
-u &ndash;udp-service service-address 说明虚拟服务器提供的是udp 的服务[vip:port] or [real-server-ip:port]<br />
-f &ndash;fwmark-service fwmark 说明是经过iptables 标记过的服务类型。<br />
-s &ndash;scheduler scheduler 使用的调度算法，选项：rr|wrr|lc|wlc|lblc|lblcr|dh|sh|sed|nq, 默认的调度算法是： wlc.<br />
-p &ndash;persistent [timeout] 持久稳固的服务。这个选项的意思是来自同一个客户的多次请求，将被同一台真实的服务器处理。timeout 的默认值为300 秒。<br />
-M &ndash;netmask netmask persistent granularity mask<br />
-r &ndash;real-server server-address 真实的服务器[Real-Server:port]<br />
-g &ndash;gatewaying 指定LVS 的工作模式为直接路由模式DR模式（也是LVS默认的模式）<br />
-i &ndash;ipip 指定LVS 的工作模式为隧道模式<br />
-m &ndash;masquerading 指定LVS 的工作模式为NAT 模式<br />
-w &ndash;weight weight 真实服务器的权值<br />
&ndash;mcast-interface interface 指定组播的同步接口<br />
&ndash;connection 显示LVS 目前的连接 如：ipvsadm -L -c<br />
&ndash;timeout 显示tcp tcpfin udp 的timeout 值 如：ipvsadm -L &ndash;timeout<br />
&ndash;daemon 显示同步守护进程状态<br />
&ndash;stats 显示统计信息<br />
&ndash;rate 显示速率信息<br />
&ndash;sort 对虚拟服务器和真实服务器排序输出<br />
&ndash;numeric -n 输出IP 地址和端口的数字形式
</pre>
</div>
<p>安装</p>
<div>
<pre class="prettyprint linenums">yum -y install ipvsadm  //这个简单，现在linux内核里面已经大部分都内置了lvs的功能，只需要安装管理工具即可</pre>
</div>
<p>配置 (重启后会消失，要写成脚本) &nbsp;参数意思看上方列表</p>
<div>
<pre class="prettyprint linenums">ipvsadm -C<br />
ipvsadm -At 192.168.100.1:80 -s rr<br />
ipvsadm -at 192.168.100.1:80 -r 192.168.100.11 -g<br />
ipvsadm -at 192.168.100.1:80 -r 192.168.100.12 -g<br />
ipvsadm -at 192.168.100.1:80 -r 192.168.100.13 -g<br />
ipvsadm
</pre>
</div>
<p>四、NGINX配置</p>
<p>###yum安装nginx并打开Nginx所在服务器的&ldquo;路由&rdquo;功能、关闭&ldquo;ARP查询&rdquo;功能###</p>
<div>
<pre class="prettyprint linenums"> yum install nginx* -y

echo "1" &gt;/proc/sys/net/ipv4/conf/lo/arp_ignore<br />
echo "2" &gt;/proc/sys/net/ipv4/conf/lo/arp_announce<br />
echo "1" &gt;/proc/sys/net/ipv4/conf/all/arp_ignore<br />
echo "2" &gt;/proc/sys/net/ipv4/conf/all/arp_announce
</pre>
</div>
<p>设置回环IP</p>
<p>ifconfig lo:0 192.168.100.1 broadcast 192.168.100.1 netmask 255.255.255.255 up<br />route add -host 192.168.100.1 dev lo:0</p>
<p>配置完毕，给nginx做个测试，看看访问是否正常，为了测试效果写了个html用于辨别几台WEB</p>
<p>vi /var/www/html/index.html &nbsp;(web1)</p>
<div>
<pre class="prettyprint linenums">&lt;html&gt;<br />
&lt;head&gt;&lt;title&gt;web1&lt;/title&gt;&lt;/head&gt;<br />
&lt;body&gt;<br />
my ip is 192.168.100.11<br />
&lt;/body&gt;<br />
&lt;/html&gt;</pre>
</div>
<p>vi /var/www/html/index.html &nbsp;(web2)</p>
<div></p>
<p>&lt;html&gt;<br />&lt;head&gt;&lt;title&gt;web2&lt;/title&gt;&lt;/head&gt;<br />&lt;body&gt;<br />my ip is 192.168.100.12<br />&lt;/body&gt;<br />&lt;/html&gt;</p>
</div>
<p>vi /var/www/html/index.html &nbsp;(web3)</p>
<div>
<pre class="prettyprint linenums">&lt;html&gt;<br />
&lt;head&gt;&lt;title&gt;web3&lt;/title&gt;&lt;/head&gt;<br />
&lt;body&gt;<br />
my ip is 192.168.100.13<br />
&lt;/body&gt;<br />
&lt;/html&gt;
</pre>
</div>
<p>五、小结一下</p>
<p>1.keepalive，安装完毕了，配置文件也没问题，没有日志报错，能够正常工作。</p>
<p>2.lvs， ipvsadm命令能看到分别的三个web服务，如果没有说明上方配置lvs时没生效</p>
<div>
<pre class="prettyprint linenums">IP Virtual Server version 1.2.1 (size=65536)<br />
Prot LocalAddress:Port Scheduler Flags<br />
  -&gt; RemoteAddress:Port           Forward Weight ActiveConn InActConn<br />
TCP  localhost:http rr<br />
  -&gt; web2:http                    Route   1      0          0<br />
  -&gt; web1:http                    Route   1      0          0<br />
  -&gt; web3:http                    Route   1      0          0
</pre>
</div>
<p>3.nginx能够正常访问，并且vip已经能够通过ifconfig查看到</p>
<p>这样应该能够访问vip了，看看展示的界面是不是会分别按照lvs的算法分配给三台nginx服务</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39rp5y48.html">gitlab 建仓的流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zzjg59.html">hdu 4521 小明系列问题&mdash;&mdash;小明序列（线段树 or DP）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvezgyq.html">Linux命令行选项及参数</a>
		</li>
						<li><a href="https://www.batexi.com/a/96onn3n9.html">EF结合SqlBulkCopy在项目中的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xeo3g9.html">502 Proxy Error。The ISA Server denied the specified Uniform Resource Locator &lpar;URL&rpar;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv11j71q.html">LeetCode &colon;&colon; Validate Binary Search Tree&lbrack;具体分析&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjd2rk8.html">runat&equals;&amp;quot&semi;server&amp;quot&semi; 是什么意思？</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yn23w8.html">SQL Server 获取本周，本月，本年等时间内记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mew4drq.html">mybatis中&dollar;和&num;java代码演示</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjg5lg8.html">mqtt实现自动监听服务器消息</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z7kr09.html">web切图的几个快捷键及总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/950vpvz8.html">FFMpeg在Ubuntu上的安装和使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdox0z9.html">速度之王 &mdash; LZ4压缩算法（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zoddd1q.html">redis常用命令大全</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rm1kj9.html">启动tomcat时报错：http-nio-8080-exec-10</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv22lox9.html">shell编程基础&lpar;六&rpar;&colon; 透彻解析查找命令find</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwx2wy8.html">border画梯形</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdrj409.html">phantomjs 截取twitter的网页（动态生成的页面）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd1xre9.html">ArrayBlockingQueue和LinkedBlockingQueue</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjngjo8.html">android 调试Installation failed with message INSTALL&lowbar;FAILED&lowbar;USER&lowbar;RESTRICTED&colon; Install canceled by user&period;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qvdermzq.html">C&plus;&plus;笔记011：C&plus;&plus;对C的扩展&mdash;&mdash;变量检测增强</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2xk3gw9.html">使用bareos备份</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlo1vzxq.html">Action与Func 用法</a>
			</li>
						<li><a href="https://www.batexi.com/a/9g3prreq.html">C&num;远程连接postgresql数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/9g3prk4q.html">php比较两个数组的差异array&lowbar;diff&lpar;&rpar;函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/90d2kw38.html">day 15 装饰器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qndn6j28.html">struts2学习笔记四</a>
			</li>
						<li><a href="https://www.batexi.com/a/90d20pm8.html">洛谷九月月赛T1 思考</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlo10mkq.html">搭建Git服务器-SCM-Manager</a>
			</li>
						<li><a href="https://www.batexi.com/a/90d25648.html">设置cell高度的两种方法（label高度的可变引起cell高度可变的情况）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
